#include<bits/stdc++.h>
using namespace std;
string a,b;
bool dali[100001];
int kude[100001];
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cin>>a;
    int N;
    cin>>N;
    int maxa=0,b1=27,mod=10e4;
    int siz=0,sizm=10000001;
    for(int i=0;i<N;i++){
        cin>>b;
        int has=0;
        for(int j=0;j<b.size();j++){
            has=has*b1+(b[j]-'a');
            has%=mod;
        }
        int siz2=b.size();
        siz=max(siz2,siz);
        sizm=min(sizm,siz2);
        dali[has]=1;
    }
    for(int i=0;i<a.size()-(sizm-1);i++){
        int has=0;
        int da=-1,kol=0;
        for(int j=i;j<a.size();j++){
            if(kude[j]!=0){
                j=kude[j];
            }
            kol++;
            if(kol>siz){
                break;
            }
            has=has*b1+(a[j]-'a');
            has%=mod;
            if(dali[has]){
                da=j;
                break;
            }
        }
        if(da!=-1){
            kude[i]=da+1;
            i=0;
        }
    }
    for(int i=0;i<a.size();i++){
        if(kude[i]!=0){
            i=kude[i];
        }
        cout<<a[i];
    }
    cout<<endl;
    return 0;
}
